/*
 * Balloon Class. Where the interesting code goes.
 */
package
{
	import flash.filters.DropShadowFilter;
	import flash.display.MovieClip;
	import com.greensock.*;

	public class Balloon extends MovieClip
	{
		[Embed(source = "../lib/balloon.png")]
		private var BalloonImage:Class;
		
		private var myTween:TweenLite;
		private var isAlive:Boolean = false;
		private var colours:Array = [0xFF0000, 0x00FF00, 0x0000FF, 0x006633, 0x16A5DF,0xFF0000, 0x00FF00, 0x0000FF, 0x006633, 0x16A5DF];
		private var score:int = 10;
		/**
		 * Inner shadow
		 * @var DropShadowFilter dropShadowEffect
		 */
		private var dropShadowEffect:DropShadowFilter;
		
		public function Balloon():void
		{
			addChild(new BalloonImage());
			isAlive = true;
			myTween = new TweenLite(this, 7, { y: -this.height, ease:"Linear.easeNone" } );
			changeColour();
		}
		
		public function reset():void
		{
			isAlive = true;
			changeColour();
			myTween.restart();
		}
		
		/**
		 * Increase the score by 1
		 * @return int the new score
		 */
		public function increaseScore():int {
			return score++;
		}
		
		public function resetScore():Balloon {
			score = 10;
			return this;
		}
		
		public function getScore():int{
			return score;
		}
		
		public function die():void
		{
			isAlive = false;
			myTween.pause();
		}
		
		public function aliveCheck():Boolean{
			return isAlive;
		}
		
		public function changeColour():void{
			dropShadowEffect = new DropShadowFilter(0,45,colours[Math.floor(Math.random() * colours.length)],1,width,height,1,1,true,false,false);
			filters = [dropShadowEffect];
		}
	}
}