package 
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.Timer;
	
	[SWF(width='800',height='600',backgroundColor='#FFFFFF',frameRate='25')]
	/**
	 * ...
	 * @author Richard Parnaby-King
	 */
	public class Main extends MovieClip 
	{
		[Embed(source="../lib/start.jpg")]
		private var StartButton:Class;
		private var startButton:Sprite = new Sprite();
		
		[Embed(source="../lib/restart.jpg")]
		private var RestartButton:Class;
		private var restartButton:Sprite = new Sprite();
		
		private var balloons:Array = [];
		private var timer:Timer = new Timer(5000, -1);
		private var score:int;
		private var textBox:TextField = new TextField;
		private var textFormat:TextFormat = new TextFormat(null, 30);
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			//add start button
			startButton.addChild(new StartButton());
			startButton.addEventListener(MouseEvent.CLICK, startGame);
			startButton.buttonMode = true;
			startButton.x = (stage.stageWidth / 2) - (startButton.width / 2);
			startButton.y = (stage.stageHeight / 2) - (startButton.height / 2);
			addChild(startButton);
			
			//instantiate the restart button
			restartButton.addChild(new RestartButton());
			restartButton.buttonMode = true;
			restartButton.x = (stage.stageWidth / 2) - (restartButton.width / 2);
			restartButton.y = (stage.stageHeight / 2) - (restartButton.height / 2);
			
			textBox.defaultTextFormat = textFormat;
			
		}
		
		private function balloonCheck(e:Event):void {
			if (balloons.length)
			{
				for (var i:int = 0; i < balloons.length; i++)
				{
					if (balloons[i].y == 0 - balloons[i].height)
					{
						removeEventListener(Event.ENTER_FRAME, balloonCheck);
						for (var j:int = 0; j < balloons.length; j++)
						{
							balloons[j].die();
							removeChild(balloons[j]);
						}
						timer.stop();
						textBox.text = "You popped " + score + " balloons!\nWell Done!";
						textBox.width = textBox.textWidth;
						textBox.x = (stage.stageWidth / 2) - (textBox.width / 2);
						textBox.y = (stage.stageHeight / 4) - (textBox.height / 2);
						addChild(textBox);
						
						restartButton.addEventListener(MouseEvent.CLICK, restartGame);
						addChild(restartButton);
						return;
					}
				}
			}
		}
		
		private function restartGame(e:MouseEvent):void {
			balloons = [];
			restartButton.removeEventListener(MouseEvent.CLICK, restartGame);
			removeChild(restartButton);
			removeChild(textBox);
			game();
		}

		private function startGame(e:MouseEvent):void {
			startButton.removeEventListener(MouseEvent.CLICK, startGame);
			removeChild(startButton);
			game();
		}
		
		private function game():void {
			addEventListener(Event.ENTER_FRAME, balloonCheck);
			timer.addEventListener(TimerEvent.TIMER_COMPLETE, createBalloon);
			timer.start();
			createBalloon();
			score = 0;
		}
		
		private function createBalloon(e:TimerEvent = null):void {
			var balloon:Balloon = new Balloon();
			balloon.addEventListener(MouseEvent.CLICK, popBalloon);
			balloon.y = stage.stageHeight;
			balloon.x = Math.floor(Math.random() * (stage.stageWidth - balloon.width));
			balloons.push(balloon);
			addChild(balloon);
			timer.reset();
			timer.start();
		}
		
		private function popBalloon(e:MouseEvent):void {
			e.target.x = Math.floor(Math.random() * (stage.stageWidth - e.target.width));
			e.target.reset();
			score++;
		}
		
	}
	
}